#!/bin/bash

frame="
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . # . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . # . # . . . . . . . . . . . .
. . . . . . . . . . . . . # # . . . . . . # # . . . . . . . . . . . . # # .
. . . . . . . . . . . . # . . . # . . . . # # . . . . . . . . . . . . # # .
. # # . . . . . . . . # . . . . . # . . . # # . . . . . . . . . . . . . . .
. # # . . . . . . . . # . . . # . # # . . . . # . # . . . . . . . . . . . .
. . . . . . . . . . . # . . . . . # . . . . . . . # . . . . . . . . . . . .
. . . . . . . . . . . . # . . . # . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . # # . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
"

while sleep 0.05; do
	echo "$frame" | cowsay -n
	frame=$(echo "$frame" | awk '
		function count(i) {
			cnt = 0;
			if (tops[i-1] == "#") cnt++;
			if (tops[i  ] == "#") cnt++;
			if (tops[i+1] == "#") cnt++;

			if (curs[i-1] == "#") cnt++;
			if (curs[i+1] == "#") cnt++;

			if (bots[i-1] == "#") cnt++;
			if (bots[i  ] == "#") cnt++;
			if (bots[i+1] == "#") cnt++;
			return cnt;
		}

		function run() {
			split(top, tops, " ")
			split(cur, curs, " ")
			split(bot, bots, " ")
			len = length(curs);
			for (i=1; i < len+1; i++) {
				new = curs[i]
				cnt = count(i)
				if (cnt <  2) new = ".";
				if (cnt == 3) new = "#";
				if (cnt >  3) new = ".";
				printf "%s%s", new, i==len ? "" : " "
			}
			print ""
		}

		// {
			top=cur; cur=bot; bot=$0
			if (cur) run()
		}

		END {
			top=cur; cur=bot; bot="";
			run();
		}
	')
done
