#get param
awk -v "key=$1" '
	BEGIN {RS=" "; FS="="}
	$1 ~ key {print $2}
'

# cut file
bnd="${CONTENT_TYPE/*boundary\=/}"

awk -v "want=$1" -v "bnd=$bnd" '
	BEGIN { RS="\r\n" }

	# reset based on boundaries
	$0 == "--"bnd""     { st=1; next; }
	$0 == "--"bnd"--"   { st=0; next; }
	$0 == "--"bnd"--\r" { st=0; next; }

	# search for wanted file
	st == 1 && $0 ~  "^Content-Disposition:.* name=\""want"\"" { st=2; next; }
	st == 1 && $0 == "" { st=9; next; }

	# wait for newline, then start printing
	st == 2 && $0 == "" { st=3; next; }
	st == 3             { print $0    }
	# head
' | head -c $((128*1024)) # Limit size to 128K

# List
awk -v 'rows=4' -v 'cols=60' '
	FNR==1      { gsub(/.*\//, "", FILENAME);
		      print FILENAME
		      print "-----" }
	FNR==1,/^$/ { next }
	/\S/        { i++; printf "%."cols"s\n", $0 }
	i>=rows     { nextfile  }
	ENDFILE     { i=0; print ""  }
' $(ls -t db/*)

# Stat
ls -l --time-style='+%Y %m' db |
awk -v 'hdr=Jan  Feb  Mar  Apr  May  Jun  Jul  Aug  Sep  Oct  Nov  Dec' '
	BEGIN { printf "%64s\n", hdr }
	NR>1  { cnt[$6+0][$7+0]++ }
	END   { for (y in cnt) {
		  printf "%4d", y
		  for (m=1; m<=12; m++)
		    printf "%5s", cnt[y][m]
		  printf "\n" } }'
